# shterm_pam_appmgr

#### Table of Contents

1. [Description](#description)
2. [Setup - The basics of getting started with shterm_pam_appmgr](#setup)
    * [Setup requirements](#setup-requirements)
3. [Reference](#usage)

## Description

Provide a function for puppet to obtain the password required by the application, to prevent the password from being configured in the manifest file.

## Setup

### Setup Requirements **OPTIONAL**

- shterm-appmgr
- puppet 4.x or above

## Reference

### Parameter introduction

- **`appid`** (str): App configuration appid information
- **`query`** (str): Standard query parameter information, key-value pairs exist, according to; split key-value pairs

### Return value introduction

-  Return value type, dict type, which is the map type. Key, with name and password. The objectName function is the account name, and the actual account can be returned when the dual account is configured. objectContent: Returns the password information corresponding to the account.

### For example:

```
$get_admin_info = {
    'appid' => 'centos',
    'query' => 'username=root;resourceName=host;reason=test;'
}
$user_and_pwd = shterm_pam_appmgr::secret($get_admin_info, '/tmp/a')
notify { "***** User=${user_and_pwd['objectName']} and Password=${user_and_pwd['objectContent']}": }
```


