require 'logger'
require 'open3'
Puppet::Functions.create_function(:'shterm_pam_appmgr::secret') do

  dispatch :secret do
    param 'Hash', :pwdAdminInfo
    param 'String', :fullLogFileName # optional
    return_type 'Hash'
  end

  def secret(pwdAdminInfo, fullLogFileName)
    @pwdAdminInfo = pwdAdminInfo
    if fullLogFileName == ""
      @logger = Logger.new(STDOUT)
    else
      @logger = Logger.new(fullLogFileName)
    end

    @logger.info("Retrieve credential with the following query:")

    @clipasswordsdk_cmd = 'll'
    queryinfo = @pwdAdminInfo['query']
    requiredAttribute = @pwdAdminInfo['requiredAttribute']
    appid = @pwdAdminInfo['appid']

    unless appid or queryinfo
        abort 'query or appid info is needed'
    end
    queryInfo = Hash.new
    value = queryinfo.split(';')
    result = Hash.new 
    value.each  do |item|
      attrKV = item.split('=')
      if attrKV.length == 2
        queryInfo[attrKV[0]] = attrKV[1]
      end
    end
    account_name = queryInfo["username"]
    resouce_name = queryInfo["resourceName"] 
    request_reason = queryInfo["reason"] 
    connect_port = queryInfo["connectPort"] 
    file = queryInfo["credentialfile"] 
    @cliPath = ENV['QIZHIAPPMGRCLI'] || '/usr/local/shterm/appmgr/plugins/pwdlibcli'
    @fullCmd = "#{@cliPath} -a #{appid}"
    if account_name
        @fullCmd = "#{@fullCmd} -o #{account_name}"
    end
    if resouce_name
        @fullCmd = "#{@fullCmd} -r #{resouce_name}"
    end
	if queryinfo
        @fullCmd = "#{@fullCmd} -q \"#{queryinfo}\""
	end	
    if request_reason
        @fullCmd = "#{@fullCmd} -R \"#{request_reason}\""
    end
    if connect_port
        @fullCmd = "#{@fullCmd} -p #{connect_port}"
    end
    if file
        @fullCmd = "#{@fullCmd} -p \"#{file}\""
    end
    if requiredAttribute
        @fullCmd = "#{@fullCmd} -A \"#{requiredAttribute}\""
    end
    result = Hash.new
    begin
      @logger.info("To execute = " + @fullCmd)
      Open3.popen3(@fullCmd) do |stdin, stdout, stderr, wait_thr|
        @logger.info("****")
        exit_status = wait_thr.value
        unless exit_status.success?
          error_msg = "#{@fullCmd}\n"
          stderr.each_line do |line|
            error_msg = "#{error_msg}\n#{line}"
          end
          abort error_msg
        end
        stdout.each_line do |line| 
          line = line.gsub("\n","")
          resultItem = line.split(':')
          if resultItem.length != 2
            abort "exec #{cmd} the line is not match result #{line}"
          end
          result[resultItem[0]] = resultItem[1]  
        end
        return result
      end
      @logger.debug(" exec #{@fullCmd} success")
     
    rescue Exception => e
      @logger.error("GetPass() : Got Exception on call to GetPassword :" + e.message )
      raise e
    end
  end
end
